#include "config.h"

static char* get_key( const char* string )
{
	char*	pt;
	char	input[128] ;

	strncpy( input, string, sizeof(input) );
	pt = strtok( input , "=" );
	return pt ;
}

static char* get_value( const char* string )
{
	char	*pt = NULL ;
	char	input[128] ;

	strncpy( input, string, sizeof(input) );

	pt = strtok( input , "=" );
	pt = strtok( NULL, "=" );
	return pt ;
}

struct config_t* load_conf_from_file( const char* file )
{
	FILE*					fd ;
	char					string[128]; 
	struct config_t*			c ;

	if( NULL == file ) {
		fprintf( stderr, "Configuration file error == NULL\n" );
		exit(1);
	}	

	fd = fopen( file, "r+" );
	if( NULL == fd ) {
		fprintf( stderr, "File descriptor is NULL\n" );
		exit(2);
	}

	c = ( struct config_t* )malloc( sizeof(struct config_t) );
	if( NULL == c ) {
		fprintf(stderr, "%s %d >> Malloc\n", __FUNCTION__, __LINE__ );
		exit(3);
	}

	while( NULL != fgets( string, sizeof(string) , fd ) ) {
		string[ strlen(string) - 1 ] = '\0' ;
		if( strncmp( get_key(string), "host", sizeof(string) ) == 0 ) {
			strncpy( c->host, get_value(string), sizeof(c->host) );
		}
		if( strncmp( get_key(string), "user", sizeof(string) ) == 0 ) {
			strncpy( c->user, get_value(string), sizeof(c->user) );
		}
		if( strncmp( get_key(string), "password", sizeof(string) ) == 0 ) {
			strncpy( c->password, get_value(string), sizeof(c->password) );
		}
		if( strncmp( get_key(string), "remote_file", sizeof(string) ) == 0 ) {
			strncpy( c->remote_file, get_value(string), sizeof(c->remote_file) );
		}
		if( strncmp( get_key(string), "enable_ftp", sizeof(string) ) == 0 ) {
			strncpy( c->enable_ftp, get_value(string), sizeof(c->enable_ftp) );
		}
		if( strncmp( get_key(string), "dev", sizeof(string) ) == 0 ) {
			strncpy( c->dev, get_value(string), sizeof(c->dev) );
		}
		if( strncmp( get_key(string), "ftp_rate", sizeof(string) ) == 0 ) {
			c->ftp_rate=atoi(get_value(string));
		}
		if( strncmp( get_key(string), "xres", sizeof(string) ) == 0 ) {
			c->x=atoi(get_value(string));
		}
		if( strncmp( get_key(string), "yres", sizeof(string) ) == 0 ) {
			c->y=atoi(get_value(string));
		}
		if( strncmp( get_key(string), "bpp", sizeof(string) ) == 0 ) {
			c->bpp=atoi(get_value(string));
		}
		
	}

	fclose( fd );

	return c ;
} 

#ifdef MAIN_CONFIG

static void show_conf( struct config_t* c )
{
	printf("user=%s\n", c->user );
	printf("host=%s\n", c->host );
	printf("password=%s\n", c->password );
	printf("remote_file=%s\n", c->remote_file );
}

int main( int argc, char** argv)
{
	struct config_t* c ;

	c = load_conf_from_file( "conf.txt" );	
	show_conf( c );
return 0;
}
#endif
